/********************************************************************************
 Author : Sijo (cic.asia@analog.com)

 Date : December 2013

 File name : AD5764.h

 Description : MACRO definition for AD5764

 Hardware plateform : ADuCM360 + AD5764
********************************************************************************/

#ifndef AD5764_H
#define AD5764_H

//REGISTER MAP

#define REGISTER_SIZE 0x03 //Size of Register in Bytes

#define READ    0x800000
#define WRITE   0x000000

#define REG_FUNCTION    0x000000
#define REG_DATA        0x100000
#define REG_COARSE_GAIN 0x180000
#define REG_FINE_GAIN   0x200000
#define	REG_OFFSET      0x280000

#define DAC_A   0x000000
#define DAC_B   0x010000
#define DAC_C   0x020000
#define DAC_D   0x030000
#define DAC_ALL 0x040000

#define RANGE_10V       0x000000
#define RANGE_10_2564V  0x000001
#define RANGE_10_5263V  0x000002

#define D0_OUTPUT 0x000004
#define D1_OUTPUT 0x000010
#define	D0_INPUT  0x000000
#define	D1_INPUT  0x000000

#define D0_HIGH 0x000002
#define D1_HIGH 0x000008
#define	D0_LOW  0x000000
#define	D1_LOW  0x000000

#define SDO_ENABLE  0x000000
#define SDO_DISABLE 0x000001

#define LOAD	0x050000

#define PIN_HIGH 0x1
#define PIN_LOW  0x0

//PIN CONFIGURATION for AD5764
#define SYNC	0x10	//P1.0
#define SCLK	0x11	//P1.1
#define SDIN	0x12	//P1.2
#define SDOUT	0x13	//P1.3

#define LDAC     0x14	//P1.4
#define CLR      0x15	//P1.5
#define BIN_COMP 0x16	//P1.6
#define RSTIN    0x17	//P1.7

#endif
