/***********************************************************************************
   @version  V1.0
   @author   Sijo (cic.asia@analog.com)
   @date     December 2013

All files for ADuCM360/361 provided by ADI, including this file, are
provided  as is without warranty of any kind, either expressed or implied.
The user assumes any and all risk from the use of this code.
It is the responsibility of the person integrating this code into an application
to ensure that the resulting application performs as required and is safe.

*************************************************************************************/
/*FUNCTION SYNTAX AND ARGUEMENTS

//		WriteCoarseGainRegister(DAC_A,RANGE_10V);	//arguements - (DAC_A/DAC_B/DAC_C/DAC_D/DAC_ALL, DAC_RANGE_10V/RANGE_10_2564V,RANGE_10_5263V)
		
//		WriteFineGainRegister(DAC_A, 0x000000);		//arguements - (DAC_A/DAC_B/DAC_C/DAC_D/DAC_ALL, Fine Gain Value in HEX)
		
//		WriteOffsetRegister(DAC_A, 0x000000);			//arguements - (DAC_A/DAC_B/DAC_C/DAC_D/DAC_ALL, Offset Value in HEX)
	
//		WriteDataRegister(DAC_ALL, 0xFFFF);				// arguements - (DAC_A/DAC_B/DAC_C/DAC_D/DAC_ALL, Data in HEX)
	
//		ConfigureD0D1(D0_OUTPUT, D1_OUTPUT);			//arguements - (D0_INPUT/D0_OUTPUT, D1_INPUT/D1_OUTPUT)
	
//		OutD0D1(D0_LOW, D1_LOW);									// arguements - (D0_HIGH/D0_LOW, D1_HIGH/D1_LOW)
	
//		ReadRegister(REG_COARSE_GAIN,DAC_A);			//arguements - (REG_FUNCTION/REG_DATA/REG_COARSE_GAIN/REG_FINE_GAIN/REG_OFFSET, DAC_A/DAC_B/DAC_C/DAC_D/DAC_ALL)

*/


#include <ADuCM360.h>
#include "AD5764.h"
#include "ADuCM360Driver.h"
#include <stdint.h>


#include "ClkLib.h"
#include "IntLib.h"
#include "DioLib.h"
#include "WdtLib.h"
#include "DioLib.h"

unsigned char InputBuf[3]={0x00,0x00,0x00};
unsigned char OutputBuf[3]={0x00,0x00,0x00};

int main()
{
	
	//unsigned long int RegCoarseGain = 0, RegFineGain = 0, RegOffset = 0, RegData = 0;
	//unsigned int CoarseGain = 0, DataValue = 0;
	unsigned int step = 0;
  ADuCM360Initialize();
	
	AD5764Initialize();
	
	WriteCoarseGainRegister(DAC_ALL,RANGE_10V);
	WriteFineGainRegister(DAC_ALL, 0x000000);	
	WriteOffsetRegister(DAC_ALL, 0x000000);
	WriteDataRegister(DAC_ALL, 0xFFFF);
	
	
		ConfigureD0D1(D0_OUTPUT, D1_OUTPUT); //arguements - (D0_INPUT/D0_OUTPUT, D1_INPUT/D1_OUTPUT)
		OutD0D1(D0_LOW, D1_LOW);
		Delay(100);
		OutD0D1(D0_HIGH, D1_HIGH);
		Delay(100);
		
	while(1)
	{
		

/*		
	//Test cases for DAC D	
		WriteCoarseGainRegister(DAC_D,RANGE_10_5263V);
		Delay(60000);
			
		WriteDataRegister(DAC_D, 0xFFFF);
		Delay(60000);
		WriteDataRegister(DAC_D, 0x0000);
		Delay(60000);
		WriteDataRegister(DAC_D, 0x4000);
		Delay(60000);
		WriteDataRegister(DAC_D, 0x8000);
		Delay(60000);
		WriteDataRegister(DAC_D, 0xC000);
		Delay(60000);
		RegData = ReadRegister(REG_DATA,DAC_D);
		DataValue = RegData;
		Delay(60);
		
			//Test cases for DAC C
		WriteCoarseGainRegister(DAC_C,RANGE_10_5263V);
		Delay(60000);
			
		WriteDataRegister(DAC_C, 0xFFFF);
		Delay(60000);
		WriteDataRegister(DAC_C, 0x0000);
		Delay(60000);
		WriteDataRegister(DAC_C, 0x4000);
		Delay(60000);
		WriteDataRegister(DAC_C, 0x8000);
		Delay(60000);
		WriteDataRegister(DAC_C, 0xC000);
		Delay(60000);
		RegData = ReadRegister(REG_DATA,DAC_C);
		DataValue = RegData;
		Delay(60);
		
		
		//Test cases for DAC B
		WriteCoarseGainRegister(DAC_B,RANGE_10_5263V);
		Delay(60000);
			
		WriteDataRegister(DAC_B, 0xFFFF);
		Delay(60000);
		WriteDataRegister(DAC_B, 0x0000);
		Delay(60000);
		WriteDataRegister(DAC_B, 0x4000);
		Delay(60000);
		WriteDataRegister(DAC_B, 0x8000);
		Delay(60000);
		WriteDataRegister(DAC_B, 0xC000);
		Delay(60000);
		RegData = ReadRegister(REG_DATA,DAC_B);
		DataValue = RegData;
		Delay(60);
		
		//Test cases for DAC A
		WriteCoarseGainRegister(DAC_A,RANGE_10_5263V);
		Delay(60000);
			
		WriteDataRegister(DAC_A, 0xFFFF);
		Delay(60000);
		WriteDataRegister(DAC_A, 0x0000);
		Delay(60000);
		WriteDataRegister(DAC_A, 0x4000);
		Delay(60000);
		WriteDataRegister(DAC_A, 0x8000);
		Delay(60000);
		WriteDataRegister(DAC_A, 0xC000);
		Delay(60000);
		RegData = ReadRegister(REG_DATA,DAC_A);
		DataValue = RegData;
		Delay(60);
		
		
		ClearData();
		LoadData();
		//Test cases for DAC ALL
		WriteCoarseGainRegister(DAC_ALL,RANGE_10V);
		LoadData();
		Delay(60000);
			
		WriteDataRegister(DAC_ALL, 0xFFFF);
		LoadData();
		Delay(60000);
		WriteDataRegister(DAC_ALL, 0x0000);
		Delay(60000);
		WriteDataRegister(DAC_ALL, 0x4000);
		Delay(60000);
		WriteDataRegister(DAC_ALL, 0x8000);
		Delay(60000);
		WriteDataRegister(DAC_ALL, 0xC000);
		Delay(60000);
		RegData = ReadRegister(REG_DATA,DAC_ALL);
		DataValue = RegData;
		Delay(60);
*/

		while(1)
		{
			for(step=0;step<0xFFFF;step=step+0x07FF)
			{
				WriteDataRegister(DAC_A, step);
				ReadRegister(REG_DATA,DAC_A);
			}

		}
		
	}
	
//	return 1;
}

